<template>
  <div
    class="grid product-container"
    itemscope
    itemtype="http://schema.org/Book"
  >
    <link
      itemprop="additionalType"
      href="http://schema.org/PublicationVolume"
    />
    <link itemprop="additionalType" href="http://schema.org/Product" />
    <link itemprop="bookFormat" href="http://schema.org/Ebook" />

    <div class="grid-col-2">
      <img
        class="product-cover-img only-desktop"
        itemprop="image"
        :src="`${$axios.defaults.baseURL}/${$i18n.locale}/images/author/${author.id}-w360.jpg`"
      />
    </div>

    <div class="grid-col-4">
      <h1 class="product-title" itemprop="name">{{ author.nickname }}</h1>
      <img
        class="product-cover-img only-mobile"
        itemprop="image"
        :src="`${$axios.defaults.baseURL}/${$i18n.locale}/images/author/${author.id}-w360.jpg`"
      />
      <div class="product-description" itemprop="about">
        <h2 class="product-description-title">
          {{ $t('author.bioTitle') }} {{ author.nickname }}
        </h2>
        <div class="product-description-content">
          <span v-html="truncateBio"></span>
          <a
            v-if="!bioIsShort"
            class="text--md text--primary read-more"
            href="#read-more"
            @click.prevent="isTruncated = !isTruncated"
          >
            {{ $t('serie.read_more') }}
          </a>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    author: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      isTruncated: true
    }
  },
  computed: {
    bioIsShort() {
      const formatted = this.formatBio(this.author.biography)
      return formatted.length <= 400
    },
    truncateBio() {
      const formatted = this.formatBio(this.author.biography)
      let text = formatted

      if (this.isTruncated) {
        if (text.length > 400) {
          text = text.slice(0, 400)
          text =
            text.substr(0, Math.min(text.length, text.lastIndexOf(' '))) + '...'
        }
      }

      return text
    }
  },
  methods: {
    formatBio(str) {
      return str.replace(/<\/?[^>]+>/gi, '<br>').replace(/(<br>)+/g, '<br>')
    }
  }
}
</script>

<style lang="scss" scoped>
.only-mobile {
  display: none;
}

.only-desktop {
  display: block;
}

@media (max-width: 768px) {
  .only-mobile {
    display: block;
  }

  .only-desktop {
    display: none;
  }
}

.grid {
  display: flex;
  flex-wrap: wrap;
  justify-content: space-between;
  margin: auto;

  [class^='grid-col'] {
    float: left;
    width: 100%;
    min-height: 1px;
    padding: 0;
  }

  .grid-col-2 {
    width: 30%;
    padding-left: 2.5%;
    padding-right: 2.5%;
  }

  .grid-col-4 {
    width: 65%;
    padding-left: 2.5%;
    padding-right: 2.5%;
  }
}

.product-title {
  margin: 0 0 7px;
  font-family: DINCond-Regular, sans-serif;
  font-weight: 100;
  font-size: 4.28571rem;
  line-height: 1;
  color: #ff641e;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -moz-line-clamp: 2;
  -o-line-clamp: 2;
  -ms-line-clamp: 2;
  -webkit-box-orient: vertical;
  -moz-box-orient: vertical;
  -o-box-orient: vertical;
  -ms-box-orient: vertical;
  overflow: initial;
}

.product-description {
  margin: 30px 0;
  font-size: 14px;
  font-size: 1rem;
  line-height: 1.71429em;

  &-title {
    margin: 15px 0;
    font-size: 18px;
    font-size: 1.28571rem;
    line-height: 1;
  }

  &-content {
    margin: 15px 0;
    max-width: 620px;
  }

  h2 {
    font-family: DINCond-Regular, sans-serif;
    font-size: 36px;
    font-weight: 400;
    text-transform: uppercase;
  }
}

@media (max-width: 767px) {
  .grid {
    flex-direction: column;
  }
}
</style>
